# Names

_Names_ are user-defined strings that name defined items. All names (variable
names, function names, etc.) follow the same rules.

Names are UTF-8 strings. The following values are _excluded_:

- Any reserved keyword
- Any whitespace character
- `.`
- `:`
- `=`
- `"` or `'`
- `[` or `]`
- `{` or `}`
- `(` or `)`

## Convention

- Variables use `lower_snake_case`
- Functions use `lower_snake_case`
- Generic Types use `UpperCamelCase` but prefer single letters such as `A`.
- Data Types, aliases, etc. use `UpperCamelCase`
